// Package docs GENERATED BY THE COMMAND ABOVE; DO NOT EDIT
// This file was generated by swaggo/swag
package docs

import (
	"bytes"
	"encoding/json"
	"strings"
	"text/template"

	"github.com/swaggo/swag"
)

var doc = `{
    "schemes": {{ marshal .Schemes }},
    "swagger": "2.0",
    "info": {
        "description": "{{escape .Description}}",
        "title": "{{.Title}}",
        "contact": {},
        "version": "{{.Version}}"
    },
    "host": "{{.Host}}",
    "basePath": "{{.BasePath}}",
    "paths": {
        "/testData/chart/lotSelection": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "查询图表-批次选项",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.ChartSelection"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/chart/pbiSelection": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "查询图表-PBI选项",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.ChartSelection"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/chart/productSelection": {
            "get": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "查询图表-产品选项",
                "parameters": [
                    {
                        "type": "string",
                        "description": "工序",
                        "name": "step",
                        "in": "query",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/cpMap": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "CP Map图",
                "parameters": [
                    {
                        "description": "CP Map图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.CPMap"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/cpMap/all": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "CP All Map图",
                "parameters": [
                    {
                        "description": "CP Map图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.CPMap"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/cpMap/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "导出CP Map图",
                "parameters": [
                    {
                        "description": "CP Map图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.CPMap"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/finalReport/excel": {
            "get": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "分页查询结批报告字段信息",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "页数",
                        "name": "page",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "每页显示数量",
                        "name": "pageSize",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "关键词",
                        "name": "key_word",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\": true, \"data\": {}, \"msg\": \"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            },
            "put": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "更新结批报告字段信息",
                "parameters": [
                    {
                        "description": "更新结批报告字段信息",
                        "name": "date",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.UpdateFinalReportExcel"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\": true, \"data\": {}, \"msg\": \"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            },
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "添加结批报告字段信息",
                "parameters": [
                    {
                        "description": "添加结批报告字段信息",
                        "name": "date",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.CreateFinalReportExcel"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\": true, \"data\": {}, \"msg\": \"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            },
            "delete": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "删除结批报告字段信息",
                "parameters": [
                    {
                        "description": "删除结批报告字段信息",
                        "name": "date",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.DeleteFinalReportExcel"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\": true, \"data\": {}, \"msg\": \"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/ftHistogram/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "导出直方图",
                "parameters": [
                    {
                        "description": "CP Map图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.Histogram"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/histogram": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "直方图",
                "parameters": [
                    {
                        "description": "直方图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.Histogram"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/line": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "折线图",
                "parameters": [
                    {
                        "description": "折线图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.Line"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/logSite": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "Log各Site差异图",
                "parameters": [
                    {
                        "description": "Log各Site差异图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.LogSiteChart"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/pie": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "饼状图",
                "parameters": [
                    {
                        "description": "饼状图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.Pie"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/ab": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "封装记录",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.ABList"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/ab/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "导出AB记录",
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/binProbability": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "测试良率-纵坐标Bin",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.BinProbability"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/bp": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "BP记录",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.BPList"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/bp/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "导出BP记录",
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/cp": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "CP记录",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.CPList"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/cp/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "导出CP记录",
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/fTPassProbabilityByFactory": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "测试良率-按供应商",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.PassProbabilityByFactory"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/fTPassProbabilityByProduct": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "测试良率-按产品型号",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.PassProbabilityByProduct"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/ft": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "FT记录",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.FTList"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/ft/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "导出FT记录",
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/packageOrderNumberBar": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "封装良率折线图",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.PackagePassProbabilityLine"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/packagePassProbabilityLine": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "封装良率折线图",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.PackagePassProbabilityLine"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/passProbability": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "测试良率-纵坐标良率",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.PassProbability"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/probabilitySelection": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "测试良率选项",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.ProbabilitySelection"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/tr": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "TR记录",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.TRList"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/tr/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "导出TR记录",
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/wafer": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "晶圆记录",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.WaferList"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/report/wafer/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台-生产"
                ],
                "summary": "导出晶圆记录",
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/scatter": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "散点图",
                "parameters": [
                    {
                        "description": "散点图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.Scatter"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/scatter/export": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "导出散点图",
                "parameters": [
                    {
                        "description": "导出散点图",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.Scatter"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/selection": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "查询参数",
                "parameters": [
                    {
                        "description": "查询参数",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.QuerySelection"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/selection/limit": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "参数极限",
                "parameters": [
                    {
                        "description": "参数极限",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.SelectionLimit"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/upload": {
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "multipart/form-data"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "上传没录入文件",
                "parameters": [
                    {
                        "type": "file",
                        "description": "file",
                        "name": "file",
                        "in": "formData",
                        "required": true
                    },
                    {
                        "type": "file",
                        "description": "product_name",
                        "name": "value",
                        "in": "formData",
                        "required": true
                    },
                    {
                        "type": "file",
                        "description": "lot",
                        "name": "value",
                        "in": "formData",
                        "required": true
                    },
                    {
                        "type": "file",
                        "description": "sub_batch",
                        "name": "value",
                        "in": "formData",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        },
        "/testData/warning": {
            "get": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "分页查询报警设置信息",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "页数",
                        "name": "page",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "每页显示数量",
                        "name": "pageSize",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "关键词",
                        "name": "key_word",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            },
            "post": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "调整报警设置信息",
                "parameters": [
                    {
                        "description": "调整报警设置信息",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/model.Warning"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            },
            "delete": {
                "security": [
                    {
                        "ApiKeyAuth": []
                    }
                ],
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "数据分析平台"
                ],
                "summary": "删除报警设置信息",
                "parameters": [
                    {
                        "description": "删除报警设置信息",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/model.Warning"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "{\"success\":true,\"data\":{},\"msg\":\"操作成功\"}",
                        "schema": {
                            "type": "string"
                        }
                    }
                }
            }
        }
    },
    "definitions": {
        "model.BinControl": {
            "type": "object",
            "properties": {
                "bin": {
                    "type": "string"
                },
                "bin_fail_limit_h": {
                    "description": "关键Bin失效上限",
                    "type": "string"
                },
                "created_at": {
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "warning_id": {
                    "type": "integer"
                }
            }
        },
        "model.HistogramSelection": {
            "type": "object",
            "properties": {
                "created_at": {
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "selection": {
                    "description": "参数",
                    "type": "string"
                },
                "warning_id": {
                    "type": "integer"
                }
            }
        },
        "model.PassProbabilityDiff": {
            "type": "object",
            "properties": {
                "created_at": {
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "pass_probability_diff": {
                    "description": "良率差异设置（报表良率）",
                    "type": "string"
                },
                "pass_probability_wave": {
                    "description": "良率波动设置（报表良率）",
                    "type": "string"
                },
                "site_pass_probability_diff": {
                    "description": "各SITE良率差异设置（一次通过率）",
                    "type": "string"
                },
                "warning_id": {
                    "type": "integer"
                }
            }
        },
        "model.ProductionControl": {
            "type": "object",
            "properties": {
                "created_at": {
                    "type": "string"
                },
                "factory": {
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "pass_quantity_diff_h": {
                    "description": "良品数量差异上限",
                    "type": "string"
                },
                "pass_quantity_diff_l": {
                    "description": "良品数量差异下限",
                    "type": "string"
                },
                "test_quantity_diff_h": {
                    "description": "测试数量差异上限",
                    "type": "string"
                },
                "test_quantity_diff_l": {
                    "description": "测试数量差异下限",
                    "type": "string"
                },
                "warning_id": {
                    "type": "integer"
                }
            }
        },
        "model.ScatterSelection": {
            "type": "object",
            "properties": {
                "created_at": {
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "warning_id": {
                    "type": "integer"
                },
                "x_selection": {
                    "description": "参数-X",
                    "type": "string"
                },
                "y_selection": {
                    "description": "参数-Y",
                    "type": "string"
                }
            }
        },
        "model.SelectionDiffControl": {
            "type": "object",
            "properties": {
                "created_at": {
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "selection": {
                    "description": "参数",
                    "type": "string"
                },
                "site_diff": {
                    "description": "SITE间差异（均值最大值-均值最小值）",
                    "type": "string"
                },
                "sub_batch_diff": {
                    "description": "批次间差异（均值最大值-均值最小值）",
                    "type": "string"
                },
                "warning_id": {
                    "type": "integer"
                }
            }
        },
        "model.StackingMaterialsWarning": {
            "type": "object",
            "properties": {
                "created_at": {
                    "type": "string"
                },
                "diff": {
                    "description": "差异",
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "quantity": {
                    "description": "数量",
                    "type": "integer"
                },
                "selection": {
                    "description": "参数",
                    "type": "string"
                },
                "unit": {
                    "description": "单位",
                    "type": "string"
                },
                "warning_id": {
                    "type": "integer"
                }
            }
        },
        "model.Warning": {
            "type": "object",
            "properties": {
                "average_pass_probability": {
                    "description": "平均良率",
                    "type": "string"
                },
                "bin_control": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/model.BinControl"
                    }
                },
                "created_at": {
                    "type": "string"
                },
                "first_pass_probability_limit_l": {
                    "description": "一次通过率下限",
                    "type": "string"
                },
                "histogram_selection": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/model.HistogramSelection"
                    }
                },
                "id": {
                    "type": "integer"
                },
                "pass_probability_diff": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/model.PassProbabilityDiff"
                    }
                },
                "pass_probability_limit_l": {
                    "description": "良率下限",
                    "type": "string"
                },
                "product": {
                    "description": "成品型号",
                    "type": "string"
                },
                "production_control": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/model.ProductionControl"
                    }
                },
                "return_probability_limit_h": {
                    "description": "回收率上限",
                    "type": "string"
                },
                "scatter_selection": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/model.ScatterSelection"
                    }
                },
                "selection_diff_control": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/model.SelectionDiffControl"
                    }
                },
                "stacking_materials_warning": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/model.StackingMaterialsWarning"
                    }
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                }
            }
        },
        "request.ABList": {
            "type": "object",
            "properties": {
                "factory": {
                    "description": "封装厂",
                    "type": "string"
                },
                "fail_quantity": {
                    "description": "封装不良品",
                    "type": "string"
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "online_quantity": {
                    "description": "在线数量",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期",
                    "type": "string"
                },
                "outsourcing_pbi": {
                    "description": "委外工单号",
                    "type": "string"
                },
                "package": {
                    "description": "封装",
                    "type": "string"
                },
                "page": {
                    "type": "integer"
                },
                "pageSize": {
                    "type": "integer"
                },
                "pass_probability": {
                    "description": "良率",
                    "type": "string"
                },
                "pass_quantity": {
                    "description": "封装良品",
                    "type": "string"
                },
                "pbi": {
                    "description": "订单号",
                    "type": "string"
                },
                "product": {
                    "description": "成品型号",
                    "type": "string"
                },
                "quantity": {
                    "description": "订单数量",
                    "type": "string"
                },
                "seal": {
                    "description": "丝印",
                    "type": "string"
                },
                "status": {
                    "description": "是否已完成",
                    "type": "string"
                },
                "stock_in_quantity": {
                    "description": "入库数",
                    "type": "string"
                },
                "stock_out_quantity": {
                    "description": "出库数",
                    "type": "string"
                },
                "wafer_id": {
                    "description": "片号",
                    "type": "string"
                },
                "wafer_product": {
                    "description": "晶圆型号",
                    "type": "string"
                }
            }
        },
        "request.BPList": {
            "type": "object",
            "properties": {
                "die_quantity": {
                    "description": "Die数量",
                    "type": "string"
                },
                "factory": {
                    "description": "CP测试厂",
                    "type": "string"
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "online_quantity": {
                    "description": "在线数量",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期",
                    "type": "string"
                },
                "outsourcing_pbi": {
                    "description": "委外工单号",
                    "type": "string"
                },
                "package": {
                    "description": "封装",
                    "type": "string"
                },
                "page": {
                    "type": "integer"
                },
                "pageSize": {
                    "type": "integer"
                },
                "pbi": {
                    "description": "订单号",
                    "type": "string"
                },
                "product": {
                    "description": "晶圆型号",
                    "type": "string"
                },
                "quantity": {
                    "description": "订单数量",
                    "type": "string"
                },
                "return_quantity": {
                    "description": "回货数量",
                    "type": "string"
                },
                "status": {
                    "description": "状态",
                    "type": "string"
                },
                "wafer_id": {
                    "description": "片号",
                    "type": "string"
                }
            }
        },
        "request.BinProbability": {
            "type": "object",
            "properties": {
                "bin": {
                    "type": "string"
                },
                "bin_type": {
                    "type": "string"
                },
                "chart_type": {
                    "type": "string"
                },
                "end_date": {
                    "type": "string"
                },
                "start_date": {
                    "type": "string"
                },
                "x": {
                    "type": "string"
                },
                "x_selection": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "request.CPList": {
            "type": "object",
            "properties": {
                "die_quantity": {
                    "description": "Die数量",
                    "type": "string"
                },
                "factory": {
                    "description": "CP测试厂",
                    "type": "string"
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "online_quantity": {
                    "description": "未交数量",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期(订单日期)",
                    "type": "string"
                },
                "package": {
                    "description": "封装(规格)",
                    "type": "string"
                },
                "page": {
                    "type": "integer"
                },
                "page_size": {
                    "type": "integer"
                },
                "pbi": {
                    "description": "PBI(订单号)",
                    "type": "string"
                },
                "product": {
                    "description": "晶圆型号",
                    "type": "string"
                },
                "quantity": {
                    "description": "订单数量",
                    "type": "string"
                },
                "return_quantity": {
                    "description": "回货数量",
                    "type": "string"
                },
                "status": {
                    "type": "string"
                },
                "test_machine": {
                    "description": "测试机台",
                    "type": "string"
                },
                "test_program": {
                    "description": "测试程序",
                    "type": "string"
                },
                "test_program_version": {
                    "description": "测试程序版本",
                    "type": "string"
                },
                "wafer_id": {
                    "description": "片号",
                    "type": "string"
                }
            }
        },
        "request.CPMap": {
            "type": "object",
            "properties": {
                "hbin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "hbin_color": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/request.CPMapColor"
                    }
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "pbi": {
                    "type": "string"
                },
                "product": {
                    "description": "产品型号",
                    "type": "string"
                },
                "sbin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "sbin_color": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/request.CPMapColor"
                    }
                },
                "selection": {
                    "description": "参数",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "selection_color": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/request.SelectionColor"
                    }
                },
                "site": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批号",
                    "type": "string"
                },
                "wafer_id": {
                    "description": "片号",
                    "type": "string"
                },
                "wafer_ids": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "request.CPMapColor": {
            "type": "object",
            "properties": {
                "color": {
                    "description": "Bin颜色",
                    "type": "string"
                },
                "name": {
                    "description": "Bin名称",
                    "type": "string"
                }
            }
        },
        "request.ChartSelection": {
            "type": "object",
            "properties": {
                "end_date": {
                    "type": "string"
                },
                "lot": {
                    "type": "string"
                },
                "product": {
                    "type": "string"
                },
                "start_date": {
                    "type": "string"
                }
            }
        },
        "request.CreateFinalReportExcel": {
            "type": "object",
            "properties": {
                "bent_stitch": {
                    "description": "弯脚",
                    "type": "string"
                },
                "bin1": {
                    "type": "string"
                },
                "bin10": {
                    "type": "string"
                },
                "bin2": {
                    "type": "string"
                },
                "bin3": {
                    "type": "string"
                },
                "bin4": {
                    "type": "string"
                },
                "bin5": {
                    "type": "string"
                },
                "bin6": {
                    "type": "string"
                },
                "bin7": {
                    "type": "string"
                },
                "bin8": {
                    "type": "string"
                },
                "bin9": {
                    "type": "string"
                },
                "factory": {
                    "description": "测试厂",
                    "type": "string"
                },
                "final_pass_probability": {
                    "description": "结批良率",
                    "type": "string"
                },
                "final_pass_quantity": {
                    "description": "结批良品数量",
                    "type": "string"
                },
                "final_test_quantity": {
                    "description": "结批测试数量",
                    "type": "string"
                },
                "lot": {
                    "description": "晶圆批次",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期",
                    "type": "string"
                },
                "other": {
                    "description": "少数",
                    "type": "string"
                },
                "outlook_fail": {
                    "description": "外观不良",
                    "type": "string"
                },
                "pbi": {
                    "description": "PBI",
                    "type": "string"
                },
                "product": {
                    "description": "成品型号",
                    "type": "string"
                },
                "scrapped": {
                    "description": "报废",
                    "type": "string"
                },
                "seal": {
                    "description": "丝印",
                    "type": "string"
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "test_program": {
                    "description": "测试程序",
                    "type": "string"
                }
            }
        },
        "request.DeleteFinalReportExcel": {
            "type": "object",
            "properties": {
                "id": {
                    "type": "integer"
                }
            }
        },
        "request.FTList": {
            "type": "object",
            "properties": {
                "factory": {
                    "description": "FT测试厂",
                    "type": "string"
                },
                "ft_fail_quantity": {
                    "description": "FT不良品",
                    "type": "string"
                },
                "ft_pass_quantity": {
                    "description": "FT良品",
                    "type": "string"
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "online_quantity": {
                    "description": "未交数量",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期(订单日期)",
                    "type": "string"
                },
                "outsourcing_pbi": {
                    "description": "委外工单号",
                    "type": "string"
                },
                "package": {
                    "description": "封装(规格)",
                    "type": "string"
                },
                "page": {
                    "type": "integer"
                },
                "page_size": {
                    "type": "integer"
                },
                "pbi": {
                    "description": "PBI(订单号)",
                    "type": "string"
                },
                "product": {
                    "description": "成品型号",
                    "type": "string"
                },
                "quantity": {
                    "description": "订单数量",
                    "type": "string"
                },
                "return_quantity": {
                    "description": "回货数量",
                    "type": "string"
                },
                "seal": {
                    "description": "丝印",
                    "type": "string"
                },
                "status": {
                    "type": "string"
                },
                "test_program": {
                    "description": "FT测试程序",
                    "type": "string"
                },
                "test_program_version": {
                    "description": "测试程序版本",
                    "type": "string"
                },
                "wafer_product": {
                    "description": "晶圆型号",
                    "type": "string"
                }
            }
        },
        "request.Histogram": {
            "type": "object",
            "properties": {
                "average": {
                    "type": "number"
                },
                "bin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "offset": {
                    "description": "偏移量",
                    "type": "number"
                },
                "only_pass": {
                    "type": "boolean"
                },
                "pbi": {
                    "description": "PBI",
                    "type": "string"
                },
                "product": {
                    "description": "产品型号",
                    "type": "string"
                },
                "selections": {
                    "description": "参数",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "site": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "splite_site": {
                    "type": "boolean"
                },
                "splite_sub_batch": {
                    "type": "boolean"
                },
                "standard_deviation": {
                    "type": "number"
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批号",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "wafer_id": {
                    "description": "片号",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "x_max": {
                    "type": "string"
                },
                "x_min": {
                    "type": "string"
                }
            }
        },
        "request.Line": {
            "type": "object",
            "properties": {
                "bin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "offset": {
                    "description": "偏移量",
                    "type": "string"
                },
                "pbi": {
                    "description": "PBI",
                    "type": "string"
                },
                "product": {
                    "description": "产品型号",
                    "type": "string"
                },
                "selection": {
                    "description": "参数",
                    "type": "string"
                },
                "site": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批号",
                    "type": "string"
                }
            }
        },
        "request.LogSiteChart": {
            "type": "object",
            "properties": {
                "bin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "content_type": {
                    "description": "内容类型",
                    "type": "string"
                },
                "lot": {
                    "type": "string"
                },
                "pbi": {
                    "type": "string"
                },
                "product": {
                    "type": "string"
                },
                "selection": {
                    "type": "string"
                },
                "site": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批",
                    "type": "string"
                }
            }
        },
        "request.PackagePassProbabilityLine": {
            "type": "object",
            "properties": {
                "date_size": {
                    "description": "时间大小",
                    "type": "string"
                },
                "factory": {
                    "description": "封装厂",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "lot": {
                    "description": "晶圆批次",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "order_date_end": {
                    "description": "下单日期结束时间",
                    "type": "string"
                },
                "order_date_start": {
                    "description": "下单日期开始时间",
                    "type": "string"
                },
                "package": {
                    "description": "封装形式",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "product": {
                    "description": "成品型号",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "request.PassProbability": {
            "type": "object",
            "properties": {
                "chart_type": {
                    "type": "string"
                },
                "end_date": {
                    "type": "string"
                },
                "start_date": {
                    "type": "string"
                },
                "x": {
                    "type": "string"
                },
                "x_selection": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "request.PassProbabilityByFactory": {
            "type": "object",
            "required": [
                "type"
            ],
            "properties": {
                "factory": {
                    "description": "封装厂",
                    "type": "string"
                },
                "type": {
                    "type": "string"
                }
            }
        },
        "request.PassProbabilityByProduct": {
            "type": "object",
            "required": [
                "product",
                "type"
            ],
            "properties": {
                "factory": {
                    "description": "封装厂",
                    "type": "string"
                },
                "product": {
                    "description": "成品型号",
                    "type": "string"
                },
                "type": {
                    "type": "string"
                }
            }
        },
        "request.Pie": {
            "type": "object",
            "properties": {
                "bin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "max": {
                    "description": "最大值",
                    "type": "string"
                },
                "min": {
                    "description": "最小值",
                    "type": "string"
                },
                "pbi": {
                    "description": "PBI",
                    "type": "string"
                },
                "pie_interval": {
                    "description": "分区间",
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/request.PieInterval"
                    }
                },
                "product": {
                    "description": "产品型号",
                    "type": "string"
                },
                "selection": {
                    "description": "参数",
                    "type": "string"
                },
                "site": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批号",
                    "type": "string"
                }
            }
        },
        "request.PieInterval": {
            "type": "object",
            "properties": {
                "max": {
                    "description": "最大值",
                    "type": "string"
                },
                "min": {
                    "description": "最小值",
                    "type": "string"
                },
                "name": {
                    "description": "区间名称",
                    "type": "string"
                }
            }
        },
        "request.ProbabilitySelection": {
            "type": "object",
            "properties": {
                "end_date": {
                    "type": "string"
                },
                "start_date": {
                    "type": "string"
                }
            }
        },
        "request.QuerySelection": {
            "type": "object",
            "properties": {
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "pbi": {
                    "description": "PBI",
                    "type": "string"
                },
                "product": {
                    "description": "产品型号",
                    "type": "string"
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批号",
                    "type": "string"
                },
                "wafer_id": {
                    "description": "片号",
                    "type": "string"
                }
            }
        },
        "request.Scatter": {
            "type": "object",
            "properties": {
                "bin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "only_pass": {
                    "type": "boolean"
                },
                "pbi": {
                    "description": "PBI",
                    "type": "string"
                },
                "product": {
                    "description": "产品型号",
                    "type": "string"
                },
                "site": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "splite_site": {
                    "type": "boolean"
                },
                "splite_sub_batch": {
                    "type": "boolean"
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批号",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "wafer_id": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "xy_selection": {
                    "description": "X string ` + "`" + `json:\"x\"` + "`" + `\nY string ` + "`" + `json:\"y\"` + "`" + `\nSelections []string ` + "`" + `json:\"selections\"` + "`" + ` // 参数",
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/request.XYSelection"
                    }
                }
            }
        },
        "request.SelectionColor": {
            "type": "object",
            "properties": {
                "color": {
                    "description": "参数颜色",
                    "type": "string"
                },
                "max": {
                    "description": "参数范围最大值",
                    "type": "string"
                },
                "min": {
                    "description": "参数范围最小值",
                    "type": "string"
                },
                "name": {
                    "description": "参数名称",
                    "type": "string"
                }
            }
        },
        "request.SelectionLimit": {
            "type": "object",
            "properties": {
                "hbin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "lot": {
                    "type": "string"
                },
                "pbi": {
                    "type": "string"
                },
                "product": {
                    "type": "string"
                },
                "sbin": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "selection": {
                    "type": "string"
                },
                "site": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "sub_batch": {
                    "description": "子批",
                    "type": "string"
                },
                "wafer_id": {
                    "type": "string"
                }
            }
        },
        "request.TRList": {
            "type": "object",
            "properties": {
                "factory": {
                    "description": "封装厂",
                    "type": "string"
                },
                "fail_quantity": {
                    "description": "FT不良品",
                    "type": "string"
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "online_quantity": {
                    "description": "在线数量",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期",
                    "type": "string"
                },
                "outsourcing_pbi": {
                    "description": "委外工单号",
                    "type": "string"
                },
                "package": {
                    "description": "封装",
                    "type": "string"
                },
                "page": {
                    "type": "integer"
                },
                "pageSize": {
                    "type": "integer"
                },
                "pass_quantity": {
                    "description": "FT良品",
                    "type": "string"
                },
                "pbi": {
                    "description": "订单号",
                    "type": "string"
                },
                "product": {
                    "description": "成品型号",
                    "type": "string"
                },
                "quantity": {
                    "description": "订单数量",
                    "type": "string"
                },
                "seal": {
                    "description": "丝印",
                    "type": "string"
                },
                "status": {
                    "description": "是否已完成",
                    "type": "string"
                },
                "wafer_product": {
                    "description": "晶圆型号",
                    "type": "string"
                }
            }
        },
        "request.UpdateFinalReportExcel": {
            "type": "object",
            "properties": {
                "bent_stitch": {
                    "description": "弯脚",
                    "type": "string"
                },
                "bin1": {
                    "type": "string"
                },
                "bin10": {
                    "type": "string"
                },
                "bin2": {
                    "type": "string"
                },
                "bin3": {
                    "type": "string"
                },
                "bin4": {
                    "type": "string"
                },
                "bin5": {
                    "type": "string"
                },
                "bin6": {
                    "type": "string"
                },
                "bin7": {
                    "type": "string"
                },
                "bin8": {
                    "type": "string"
                },
                "bin9": {
                    "type": "string"
                },
                "factory": {
                    "description": "测试厂",
                    "type": "string"
                },
                "final_pass_probability": {
                    "description": "结批良率",
                    "type": "string"
                },
                "final_pass_quantity": {
                    "description": "结批良品数量",
                    "type": "string"
                },
                "final_test_quantity": {
                    "description": "结批测试数量",
                    "type": "string"
                },
                "id": {
                    "type": "integer"
                },
                "lot": {
                    "description": "晶圆批次",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期",
                    "type": "string"
                },
                "other": {
                    "description": "少数",
                    "type": "string"
                },
                "outlook_fail": {
                    "description": "外观不良",
                    "type": "string"
                },
                "pbi": {
                    "description": "PBI",
                    "type": "string"
                },
                "product": {
                    "description": "成品型号",
                    "type": "string"
                },
                "scrapped": {
                    "description": "报废",
                    "type": "string"
                },
                "seal": {
                    "description": "丝印",
                    "type": "string"
                },
                "step": {
                    "description": "工序",
                    "type": "string"
                },
                "test_program": {
                    "description": "测试程序",
                    "type": "string"
                }
            }
        },
        "request.WaferList": {
            "type": "object",
            "properties": {
                "factory": {
                    "description": "晶圆厂",
                    "type": "string"
                },
                "lot": {
                    "description": "批号",
                    "type": "string"
                },
                "online_quantity": {
                    "description": "在线数量",
                    "type": "string"
                },
                "order_date": {
                    "description": "下单日期",
                    "type": "string"
                },
                "page": {
                    "type": "integer"
                },
                "pageSize": {
                    "type": "integer"
                },
                "pbi": {
                    "description": "订单号",
                    "type": "string"
                },
                "product": {
                    "description": "晶圆型号",
                    "type": "string"
                },
                "quantity": {
                    "description": "投片数量",
                    "type": "string"
                },
                "return_date": {
                    "description": "回货日期",
                    "type": "string"
                },
                "return_quantity": {
                    "description": "回货数量",
                    "type": "string"
                },
                "status": {
                    "description": "状态",
                    "type": "string"
                },
                "wafer_size": {
                    "description": "晶圆尺寸",
                    "type": "string"
                }
            }
        },
        "request.XYSelection": {
            "type": "object",
            "properties": {
                "x": {
                    "type": "string"
                },
                "y": {
                    "type": "string"
                }
            }
        }
    }
}`

type swaggerInfo struct {
	Version     string
	Host        string
	BasePath    string
	Schemes     []string
	Title       string
	Description string
}

// SwaggerInfo holds exported Swagger Info so clients can modify it
var SwaggerInfo = swaggerInfo{
	Version:     "",
	Host:        "",
	BasePath:    "",
	Schemes:     []string{},
	Title:       "",
	Description: "",
}

type s struct{}

func (s *s) ReadDoc() string {
	sInfo := SwaggerInfo
	sInfo.Description = strings.Replace(sInfo.Description, "\n", "\\n", -1)

	t, err := template.New("swagger_info").Funcs(template.FuncMap{
		"marshal": func(v interface{}) string {
			a, _ := json.Marshal(v)
			return string(a)
		},
		"escape": func(v interface{}) string {
			// escape tabs
			str := strings.Replace(v.(string), "\t", "\\t", -1)
			// replace " with \", and if that results in \\", replace that with \\\"
			str = strings.Replace(str, "\"", "\\\"", -1)
			return strings.Replace(str, "\\\\\"", "\\\\\\\"", -1)
		},
	}).Parse(doc)
	if err != nil {
		return doc
	}

	var tpl bytes.Buffer
	if err := t.Execute(&tpl, sInfo); err != nil {
		return doc
	}

	return tpl.String()
}

func init() {
	swag.Register(swag.Name, &s{})
}
