package test_data

import (
	"errors"
	"sort"
	"testData/model"
	"testData/repository"
)

func HandleUploadFiles(fileTexts []*model.FileText, step, machine string) error {
	if step == "" {
		return errors.New("未输入工序")
	}
	sort.Slice(fileTexts, func(i, j int) bool {
		return fileTexts[i].Name < fileTexts[j].Name
	})
	if machine == "STS8200" {
		for _, fileText := range fileTexts {
			repository.HandleSTS8200Excel(fileText, step)
		}
	} else if machine == "TQT601" {
		for _, fileText := range fileTexts {
			repository.HandlerTQT601Excel(fileText, step)
		}
	} else if machine == "MT737" {
		for i := 0; i < len(fileTexts)/2; i++ {
			repository.MT737(fileTexts[2*i+1], fileTexts[2*i], step)
		}
	}
	return nil
}
