package request

type PackagePassProbabilityLine struct {
	Product        []string `json:"product"`          // 成品型号
	Lot            []string `json:"lot"`              // 晶圆批次
	Package        []string `json:"package"`          // 封装形式
	Factory        []string `json:"factory"`          // 封装厂
	OrderDateStart string   `json:"order_date_start"` // 下单日期开始时间
	OrderDateEnd   string   `json:"order_date_end"`   // 下单日期结束时间
	DateSize       string   `json:"date_size"`        // 时间大小
}

type PassProbabilityByFactory struct {
	Factory string `json:"factory"` // 封装厂
	Type    string `json:"type" validate:"required"`
}

type PassProbabilityByProduct struct {
	Product string `json:"product" validate:"required"` // 成品型号
	Factory string `json:"factory"`                     // 封装厂
	Type    string `json:"type" validate:"required"`
}

type TestPassProbabilityLine struct {
	Product        string `json:"product"`          // 成品型号
	Lot            string `json:"lot"`              // 晶圆批次
	Factory        string `json:"factory"`          // 测试厂
	TestProgram    string `json:"test_program"`     // 测试程序
	TestMachine    string `json:"test_machine"`     // 测试机台
	OrderDateStart string `json:"order_date_start"` // 下单日期开始时间
	OrderDateEnd   string `json:"order_date_end"`   // 下单日期结束时间
	DateSize       string `json:"date_size"`        // 时间大小
}

type PassProbability struct {
	Step      string   `json:"step"`
	StartDate string   `json:"start_date"`
	EndDate   string   `json:"end_date"`
	X         []string `json:"x"`
	Product   []string `json:"product"`
	Lot       []string `json:"lot"`
	ChartType string   `json:"chart_type"`
	Group     []string `json:"group"`
}

type BinProbability struct {
	Step      string   `json:"step"`
	StartDate string   `json:"start_date"`
	EndDate   string   `json:"end_date"`
	X         []string `json:"x"`
	Product   []string `json:"product"`
	Lot       []string `json:"lot"`
	ChartType string   `json:"chart_type"`
	Bin       string   `json:"bin"`
	BinType   string   `json:"bin_type"`
	Group     []string `json:"group"`
}

type ProbabilitySelection struct {
	Step      string `json:"step"`
	StartDate string `json:"start_date"`
	EndDate   string `json:"end_date"`
}
