package request

type WaferList struct {
	Status         string `json:"status"`          // 状态
	OrderDate      string `json:"order_date"`      // 下单日期
	PBI            string `json:"pbi"`             // 订单号
	Product        string `json:"product"`         // 晶圆型号
	Factory        string `json:"factory"`         // 晶圆厂
	WaferSize      string `json:"wafer_size"`      // 晶圆尺寸
	Quantity       string `json:"quantity"`        // 投片数量
	OnlineQuantity string `json:"online_quantity"` // 在线数量
	ReturnDate     string `json:"return_date"`     // 回货日期
	Lot            string `json:"lot"`             // 批号
	ReturnQuantity string `json:"return_quantity"` // 回货数量
	Page           int    `json:"page"`
	PageSize       int    `json:"pageSize"`
}

type ABList struct {
	Status           string `json:"status"`             // 是否已完成
	OrderDate        string `json:"order_date"`         // 下单日期
	PBI              string `json:"pbi"`                // 订单号
	OutsourcingPBI   string `json:"outsourcing_pbi"`    // 委外工单号
	Product          string `json:"product"`            // 成品型号
	WaferProduct     string `json:"wafer_product"`      // 晶圆型号
	Package          string `json:"package"`            // 封装
	Factory          string `json:"factory"`            // 封装厂
	Lot              string `json:"lot"`                // 批号
	Seal             string `json:"seal"`               // 丝印
	WaferID          string `json:"wafer_id"`           // 片号
	Quantity         string `json:"quantity"`           // 订单数量
	OnlineQuantity   string `json:"online_quantity"`    // 在线数量
	PassProbability  string `json:"pass_probability"`   // 良率
	StockOutQuantity string `json:"stock_out_quantity"` // 出库数
	StockInQuantity  string `json:"stock_in_quantity"`  // 入库数
	PassQuantity     string `json:"pass_quantity"`      // 封装良品
	FailQuantity     string `json:"fail_quantity"`      // 封装不良品
	Page             int    `json:"page"`
	PageSize         int    `json:"pageSize"`
}

type BPList struct {
	Status         string `json:"status"`          // 状态
	OrderDate      string `json:"order_date"`      // 下单日期
	PBI            string `json:"pbi"`             // 订单号
	OutsourcingPBI string `json:"outsourcing_pbi"` // 委外工单号
	Product        string `json:"product"`         // 晶圆型号
	Package        string `json:"package"`         // 封装
	Factory        string `json:"factory"`         // CP测试厂
	Lot            string `json:"lot"`             // 批号
	WaferID        string `json:"wafer_id"`        // 片号
	Quantity       string `json:"quantity"`        // 订单数量
	OnlineQuantity string `json:"online_quantity"` // 在线数量
	ReturnQuantity string `json:"return_quantity"` // 回货数量
	DieQuantity    string `json:"die_quantity"`    // Die数量
	Page           int    `json:"page"`
	PageSize       int    `json:"pageSize"`
}

type CPList struct {
	Status             string `json:"status"`
	OrderDate          string `json:"order_date"`           // 下单日期(订单日期)
	PBI                string `json:"pbi"`                  // PBI(订单号)
	Product            string `json:"product"`              // 晶圆型号
	Package            string `json:"package"`              // 封装(规格)
	Factory            string `json:"factory"`              // CP测试厂
	Lot                string `json:"lot"`                  // 批号
	WaferID            string `json:"wafer_id"`             // 片号
	TestProgram        string `json:"test_program"`         // 测试程序
	TestProgramVersion string `json:"test_program_version"` // 测试程序版本
	Quantity           string `json:"quantity"`             // 订单数量
	OnlineQuantity     string `json:"online_quantity"`      // 未交数量
	ReturnQuantity     string `json:"return_quantity"`      // 回货数量
	DieQuantity        string `json:"die_quantity"`         // Die数量
	TestMachine        string `json:"test_machine"`         // 测试机台
	Page               int    `json:"page"`
	PageSize           int    `json:"page_size"`
}

type FTList struct {
	Status             string `json:"status"`
	OrderDate          string `json:"order_date"`           // 下单日期(订单日期)
	PBI                string `json:"pbi"`                  // PBI(订单号)
	OutsourcingPBI     string `json:"outsourcing_pbi"`      // 委外工单号
	Product            string `json:"product"`              // 成品型号
	WaferProduct       string `json:"wafer_product"`        // 晶圆型号
	Package            string `json:"package"`              // 封装(规格)
	Factory            string `json:"factory"`              // FT测试厂
	Lot                string `json:"lot"`                  // 批号
	Seal               string `json:"seal"`                 // 丝印
	TestProgram        string `json:"test_program"`         // FT测试程序
	TestProgramVersion string `json:"test_program_version"` // 测试程序版本
	Quantity           string `json:"quantity"`             // 订单数量
	OnlineQuantity     string `json:"online_quantity"`      // 未交数量
	ReturnQuantity     string `json:"return_quantity"`      // 回货数量
	FTPassQuantity     string `json:"ft_pass_quantity"`     // FT良品
	FTFailQuantity     string `json:"ft_fail_quantity"`     // FT不良品
	Page               int    `json:"page"`
	PageSize           int    `json:"page_size"`
}

type TRList struct {
	Status         string `json:"status"`          // 是否已完成
	OrderDate      string `json:"order_date"`      // 下单日期
	PBI            string `json:"pbi"`             // 订单号
	OutsourcingPBI string `json:"outsourcing_pbi"` // 委外工单号
	Product        string `json:"product"`         // 成品型号
	WaferProduct   string `json:"wafer_product"`   // 晶圆型号
	Package        string `json:"package"`         // 封装
	Factory        string `json:"factory"`         // 封装厂
	Lot            string `json:"lot"`             // 批号
	Seal           string `json:"seal"`            // 丝印
	Quantity       string `json:"quantity"`        // 订单数量
	OnlineQuantity string `json:"online_quantity"` // 在线数量
	PassQuantity   string `json:"pass_quantity"`   // FT良品
	FailQuantity   string `json:"fail_quantity"`   // FT不良品
	Page           int    `json:"page"`
	PageSize       int    `json:"pageSize"`
}
