package router

import (
	"github.com/gin-gonic/gin"
	test_data "testData/api/test.data"
)

func InitChartRouter(R *gin.RouterGroup) {
	chartService := test_data.InitTestService()
	chartGroup := R.Group("")
	{
		chartGroup.POST("selection", chartService.Selection)
		chartGroup.POST("histogram", chartService.Histogram)
		chartGroup.POST("scatter", chartService.Scatter)
		chartGroup.POST("pie", chartService.Pie)
		chartGroup.POST("line", chartService.Line)
		chartGroup.POST("cpMap", chartService.CPMap)
		chartGroup.POST("cpMap/all", chartService.AllCPMap)
		chartGroup.POST("cpMap/export", chartService.CPMapExport)
		chartGroup.POST("ftHistogram/export", chartService.ExportHistogram)
		chartGroup.POST("scatter/export", chartService.ExportScatter)
		chartGroup.POST("logSite", chartService.LogSite)
		chartGroup.POST("selection/limit", chartService.SelectionLimit)
	}
}
