package utils

import (
	"github.com/gin-gonic/gin"
	"strconv"
)

// PaginationLimitAndPage 获取分页page与pageSize, 返回gorm需要的limit,offset与一个error
func PaginationLimitAndPage(c *gin.Context) (int, int, error) {
	limit, err := strconv.Atoi(c.Query("pageSize"))
	page, err := strconv.Atoi(c.Query("page"))
	if err != nil {
		return 0, 0, err
	}
	if page > 0 {
		page--
	}
	return page * limit, limit, nil
}
